/*
 * Designed and developed by 2021 skydoves (Jaewoong Eum)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.skydoves.moviecompose.persistence

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import androidx.room.Update
import com.skydoves.moviecompose.models.entities.Person

@Dao
interface PeopleDao {
  @Insert(onConflict = OnConflictStrategy.REPLACE)
  suspend fun insertPeople(people: List<Person>)

  @Update
  suspend fun updatePerson(person: Person)

  @Query("SELECT * FROM people WHERE id = :id_")
  suspend fun getPerson(id_: Long): Person

  @Query("SELECT * FROM People WHERE page = :page_")
  suspend fun getPeople(page_: Int): List<Person>
}
